/*
** HASH: Simple hash table implementation.
** Copyright (C) 2002 Michael W. Shaffer <mwshaffer@angrypot.com>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.  
**
** You should have received a copy of the GNU General Public License
** along with this program (see the file COPYING). If not, write to:
**
** The Free Software Foundation, Inc.
** 59 Temple Place, Suite 330,
** Boston, MA  02111-1307  USA
*/

#ifndef HASH_H
#define HASH_H

struct datum {
	void *key;
	unsigned long ksize;
	void *val;
	unsigned long vsize;
};

struct hash_table {
	unsigned long size;
	struct list *tbl;
};

void hash_table_init (struct hash_table *h);
void hash_table_free (struct hash_table *h);
struct datum *hash_table_insert (struct hash_table *h, struct datum *d);
struct datum *hash_table_search (struct hash_table *h, struct datum *k);
void hash_table_delete (struct hash_table *h, struct datum *k);

#endif /* HASH_H */

