/*
** PRIMES: Simple prime number functions
** Copyright (C) 2002 Michael W. Shaffer <mwshaffer@angrypot.com>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.  
**
** You should have received a copy of the GNU General Public License
** along with this program (see the file COPYING). If not, write to:
**
** The Free Software Foundation, Inc.
** 59 Temple Place, Suite 330,
** Boston, MA  02111-1307  USA
*/

#include <math.h>

unsigned long find_prime (unsigned long max)
{
	unsigned long i = 0;
	unsigned long f = 0;
	unsigned long prime = 1;

	for (i = max ; i > 1 ; i--) {
		if ((i % 2) == 0)
			goto NOTPRIME;
		for (f = 2 ; f <= ((unsigned long) floor (sqrt (i))) ; f++) {
			if ((i % f) == 0)
				goto NOTPRIME;
		}
		prime = i;
		goto EXIT;
NOTPRIME:
		continue;
	}

EXIT:
	return prime;
}

